# Vivian OpenVR Test Project

This repository contains a complete Unity project with the necessary modules for building a Vivian based application for VR.
The necessary modules for running this project are contained within [Git Submodules](https://git-scm.com/book/en/v2/Git-Tools-Submodules). In order to get the project running, you will need to initialize the submodules (i.e. clone them within the project) as they are not cloned automatically upon cloning the main project.

## Initialize the Project

1. Clone the project and initialize the submodules.
+ In a GUI client, this can be proposed to you when cloning the project.
+ If you use Git through the CLI, run this command to have the submodules directly checked out:
`git clone --recurse-submodules https://gitlab.com/usability-engineering-ar-mr-vr/vivian-framework/vivian-openvr-test-project.git`

2. Download the matching version of Unity used for this project: **2019.4.1f1**. This can be done through the Unity Hub.

3. Add the cloned project into Unity Hub. Just navigate to the root folder and click **Select Folder**.

4. The different prototypes are configured within their respective scene (*Assets/Scenes*). In addition, there are two scenes per prototype:
+ one for a controller-based interaction using a virtual laser pointer
+ one for a hand-based interaction using the Leap Motion hand tracker.

5. Build the prototypes' Asset Bundles: *Assets > Build Vivian Prototype Bundles*.

6. For understanding how prototypes are made, built, and used in the scenes, see the [Vivian Framework](#vivian-framework) section.

7. Run the application

## Vivian Framework

##### VivianFramework Game Object
This prefab contains the **Virtual Prototype** script that takes two parameters: 
+ **Bundle URL**: local or remote URL that points to the prototype. A local URL can point to an [AssetBundle](#asset-bundles) or a folder from the **Vivian Example Prototypes/Resources** package. Valid examples (depending on selected URL, the prefab must be inside the folder or the asset bundle denoted by the URL):
  + AssetBundles/Android/coffeemachine
  + Microwave
+ **Prototype Prefab Name**: name of the prefab created after the prototype model. Prototypes usually contain two declinations of prefabs: one based on a blender source file (`.blend`), one based on the `.fbx` model file system. Valid examples:
  + microwave
  + coffeemachine2

### Asset Bundles Folder
Asset Bundles are archives generated by Unity. They are used in the Vivian Framework to contain the virtual prototypes' models, materials, functional specification, or any resources that are included in their *Example Prototype/Resources* folder (see the **Vivian Example Prototypes** submodule).

The creation of Asset Bundles is only required if you reference an Asset Bundle in the VivianFramework prefab. In case you reference a prototype directly from within the Resources folder in the **Vivian Example Prototypes** package, then the creation is not required.

To generate them, click *Assets > Build Vivian Prototype Bundles*. This creates an **AssetBundles** folder in the **Assets** folder, if it doesn't already exist. Another folder is created inside, depending on the build target, in our case, **Windows**. The AssetBundles are contained there.

